pro plfold,fac,cfile=cfi,norm=norm,weights=weights,eps=eps,wrange=wr
; plot spectra folded over phase
; fac  : contrast factor for image (useful for the postsctript output)
get_lun,lun
if n_elements(fac) eq 0 then fac =1
if n_elements(weights) eq 0 then weights=1
if n_elements(cfi) eq 0 then cfi='foldspec'
if n_elements(wr) ne 0 and n_elements(wr) ne 2 then begin
  print,'wr must 2-element array: [wavelength1,wwavelength2]'
  return
endif
openr,lun,cfi
nbin=1
nwo=1
readu,lun,nbin,nwo
trsp=fltarr(nbin,nwo)
w=fltarr(nwo)
wt=fltarr(nbin)
readu,lun,w
readu,lun,trsp
readu,lun,wt
istr=''
readf,lun,istr
close,lun
i0=0
i1=nwo
wr=[w(0),w(nwo-1)]
if n_elements(wr) eq 2 then iwr=interpol(indgen(nwo),w,wr)
i0=max([0,iwr(0)])
i1=min([nwo,iwr(1)])
if keyword_set(norm) then for i=0,nbin-1 do trsp(i,*)=trsp(i,*)/total(trsp(i,i0:i1))
npy=300  ;nominal number of pixels vertical
isy=fix(npy/nbin)   ;factor for stretching in y
npx=800   ;nominal no of pix in x
nlf=max([1,fix(npx/(i1-i0))])
;tstr=string(format='(''fac='',f5.1)',fac)
  tstr=' '
set_plot, 'x'
loadct,3,/silent
mcol=!d.table_size-1
window,0,xsize=npx,ysize=npy
offs=40
set_plot,'ps'
mcolp=!d.table_size-1 ; max no of colors of display
device,/landscape,font_size=14,bits_per_pixel=8,xsize=30,ysize=30
off=0.1
device,filename='foldspec.ps'
if keyword_set(eps) then device,/encaps else device,encap=0

nbf=2   ; number of repeats in phase
wy=[0,nbf]
nl=i1-i0
trs=fltarr(nbf*nbin,nl)
; repeat in phase direction
for irep=0,nbf-1 do trs(irep*nbin:irep*nbin+nbin-1,*)= $
  trsp(0:nbin-1,i0:i1-1)

sma=max(trs)
d=rotate((fac*trs/sma>0)<1,4)
; make weight histogram
wt=wt/total(wt)*nbin
xm=0.05
wm=xm*wr(1)+(1-xm)*wr(0)
wt=wr(0)+(wm-wr(0))*wt
xw=findgen(nbin)/nbin
xw=[xw,1+xw]
n2=2*nbin
y=[wt,wt]
xw=[xw,2]
histo,n2,xw,y,xx,yy

; make `atmosphere subtracted' spectrum
; first get phase-dependence of continuum
ww=w(0.4*nwo:0.6*nwo)
nww=n_elements(ww)
trw=trs(*,0.4*nwo:0.6*nwo)
trb=total(trw,1)/n2
ind=sort(trb)
f=0.25
indf=ind((1-f)*0.5*nww:(1+f)*0.5*nww)
nwf=n_elements(indf)
clev=total(trw(*,indf),2)/nwf             ; this is continuum as fn of phase
cla=total(clev)/n2
trsc=trs
for i=0,nl-1 do trsc(*,i)=trs(*,i)/clev   ; spectrum divided by phase-dependence
tra=total(trsc,1)/n2                    ; phase-average minus continuum
df=rotate((fac*trsc*cla/sma>0)<1,4)
for i=0,n2-1 do trsc(i,*)=trsc(i,*)-tra+1  ; phase avg subtracted, contin added
for i=0,nl-1 do trsc(*,i)=trsc(*,i)*clev  ; restore phase dependence
dr=rotate((fac*trsc/sma>0)<1,4)

set_plot,'x'
plot,wr,4*wy,/nodata,/device,xra=wr,yra=4*wy,xsty=5,ysty=5
px=!x.window*!d.x_vsize
py=!y.window*!d.y_vsize
sx=px(1)-px(0)+1
sy=py(1)-py(0)+1
tv,congrid(d*mcol,sx,sy/4),px(0),py(0)
tv,congrid((1-d)*mcol,sx,sy/4),px(0),sy/4+py(0)
tv,congrid(df*mcol,sx,sy/4),px(0),sy/2+py(0)
tv,congrid((1-dr)*mcol,sx,sy/4),px(0),sy*0.75+py(0)
plot,wr,4*wy,/nodata,/device,title=istr+tstr,xra=wr,yra=4*wy,$
  xsty=1,ysty=1,/noerase
if weights eq 1 then oplot,yy,xx

set_plot,'ps'
xsiz=0.7
ysiz=0.3
plot,wr,wy,position=[0,off,xsiz,ysiz+off],psym=3,xsty=5,ysty=5,$
  xtitle='waveln',ytitle='phase',title=istr+tstr 
yl=!y.window(1)-!y.window(0)
xl=!x.window(1)-!x.window(0)
tv,mcolp*d,!x.window(0),!y.window(0),$
  xsize=xl,ysize=yl/4,/norm
tv,mcolp*(1-d),!x.window(0),!y.window(0)+yl/4,$
  xsize=xl,ysize=yl/4,/norm
tv,mcolp*df,!x.window(0),!y.window(0)+yl/2,$
  xsize=xl,ysize=yl/4,/norm
tv,mcolp*(1-dr),!x.window(0),!y.window(0)+yl*0.75,$
  xsize=xl,ysize=yl/4,/norm
plot,wr,wy*4,position=[0,off,xsiz,ysiz+off],psym=3,xsty=1,ysty=1,$
  /noerase
if weights eq 1 then oplot,yy,xx,color=0


device,/close_file

set_plot,'x'
return
end

